unit uDemo;

interface

Uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Spin, Menus;

type
	TForm1 = class(TForm)
		ColorDialog1: TColorDialog;
		Panel2: TPanel;
    Timer1: TTimer;
    Notebook1: TNotebook;
    Image1: TImage;
    Panel1: TPanel;
    GroupBox2: TGroupBox;
    btnFill: TBitBtn;
    btnPen: TBitBtn;
    EditTitle: TEdit;
    btnDelete: TBitBtn;
    GroupBox3: TGroupBox;
    btnUp: TSpeedButton;
    btnLeft: TSpeedButton;
    btnExtents: TSpeedButton;
		btnRight: TSpeedButton;
		btnDown: TSpeedButton;
		Label2: TLabel;
    Label3: TLabel;
		Label1: TLabel;
		SpinLongitude: TSpinEdit;
    SpinLatitude: TSpinEdit;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    cbxLayer0: TCheckBox;
    cbxLayer1: TCheckBox;
    cbxLayer2: TCheckBox;
    cbxLayer3: TCheckBox;
    cbxLayer4: TCheckBox;
    spinDetail: TSpinEdit;
    Globe: TGlobe;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Options1: TMenuItem;
    ShowGrid1: TMenuItem;
		Gridinfront1: TMenuItem;
    N1: TMenuItem;
    MercatorProjection1: TMenuItem;
    Overlay11: TMenuItem;
    Overlay21: TMenuItem;
    N2: TMenuItem;
		Exit1: TMenuItem;
		Help1: TMenuItem;
    Overlay31: TMenuItem;
		OpenDialog1: TOpenDialog;
    lblObject: TLabel;
		SaveDialog1: TSaveDialog;
    BaseGlobeFile1: TMenuItem;
    Save1: TMenuItem;
    N3: TMenuItem;
		GroupBox1: TGroupBox;
    SpinEdit1: TSpinEdit;
    cbxEnableUser: TCheckBox;
    Label4: TLabel;
    SpinLayer: TSpinEdit;
		Label6: TLabel;
		procedure GlobeMouseDown(Sender: TObject; Button: TMouseButton;
			Shift: TShiftState; X, Y: Integer);
		procedure GlobeMouseMove(Sender: TObject; Shift: TShiftState; X,
			Y: Integer);
		procedure cbxLayer0Click(Sender: TObject);
		procedure EditTitleChange(Sender: TObject);
		procedure btnDeleteClick(Sender: TObject);
		procedure btnUpClick(Sender: TObject);
		procedure btnDownClick(Sender: TObject);
		procedure btnRightClick(Sender: TObject);
		procedure btnLeftClick(Sender: TObject);
		procedure spinDetailChange(Sender: TObject);
		procedure FormKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure SpinLatLongChange(Sender: TObject);
		procedure btnFillClick(Sender: TObject);
		procedure btnPenClick(Sender: TObject);
		procedure btnExtentsClick(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure GlobePaint(Sender: TObject);
		procedure Timer1Timer(Sender: TObject);
		procedure Button1Click(Sender: TObject);
		procedure SpinEdit1Change(Sender: TObject);
		procedure GlobeZoomed(Sender: TObject);
		procedure GlobeDblClick(Sender: TObject);
		procedure Image1Click(Sender: TObject);
		procedure MercatorProjection1Click(Sender: TObject);
		procedure ShowGrid1Click(Sender: TObject);
		procedure Gridinfront1Click(Sender: TObject);
		procedure Exit1Click(Sender: TObject);
		procedure Overlay11Click(Sender: TObject);
		procedure Overlay21Click(Sender: TObject);
		procedure Overlay31Click(Sender: TObject);
    procedure BaseGlobeFile1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SpinLayerChange(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }
		procedure DisplayHint(Sender: TObject);
		procedure LoadOverlay( Sender : TObject; idx: integer );
		procedure DisplayObjectData;
		procedure UpdateGlobe;
	end;

var
	Form1: TForm1;
	iLong : integer;

implementation

{$R *.DFM}

{-------------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
	iLong := 0;

	Application.OnHint := DisplayHint;
	Show;
	Application.ProcessMessages;
	Globe.Globefile := ExtractFilePath( Paramstr(0)) + 'Globe.Dat';
{	Globe.Overlays[0].Enabled := False;}

	{ Use the default rotations from the globe file }
	Globe.XRotation := Globe.Overlays[0].XRotation;
	Globe.YRotation := Globe.Overlays[0].YRotation;

	Globe.Overlays[3].AddPointText( 10, 10, 'Hello World', 0, 32 );

	DisplayObjectData;
end;

{-------------------------------------------------------------------------}
procedure TForm1.DisplayObjectData;
begin
	with Globe do
	begin
		btnDelete.Enabled := ( SelectedObject <> nil );
		btnFill.Enabled := ( SelectedObject <> nil );
		btnPen.Enabled := ( SelectedObject <> nil );
		SpinLayer.Enabled := ( SelectedObject <> nil );

		if SelectedObject <> nil then
			with SelectedObject do
			begin
				SpinLayer.Value := Layer;
					lblObject.Caption := Format( 'Origin %s'+#10+'Kind %d Overlay %d Id %d PointCount %d',
					[ LLPointAsString( Origin ), Kind, OverlayIndex, Index, Count ] );
				EditTitle.Text := SelectedObject.Title;
			end
			else
			begin
				lblObject.Caption := 'None';
				editTitle.text := '';
			end;
	end;
end;

{-------------------------------------------------------------------------}
procedure TForm1.LoadOverlay( Sender : TObject; idx: integer );
begin
	try
		if Length( Globe.Overlays[idx].Filename ) > 0 then
			Globe.Overlays[idx].Clear
		else
		begin
			OpenDialog1.FileName := Globe.Overlays[idx].Filename;
			if OpenDialog1.Execute then
				Globe.Overlays[idx].LoadFromFile( OpenDialog1.FileName );
		end;
	finally
		TMenuItem( Sender ).Checked := Globe.Overlays[idx].Enabled;
	end;
end;

{-------------------------------------------------------------------------}
procedure TForm1.UpdateGlobe;
begin
	with Globe do
	begin
		if not ShowGrid1.Checked then
				DrawGrid := dgNone
		else
			if Gridinfront1.Checked then
				DrawGrid := dgInFront
			else
				DrawGrid := dgBehind;

		if MercatorProjection1.Checked then
			Projection := gpMercator
		else
			Projection := gpSpherical;
	end;
end;


{-------------------------------------------------------------------------}
procedure TForm1.GlobeMouseDown(Sender: TObject;
	Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	with Globe do
		if Button = mbLeft then
		begin
			SelectedObject := ObjectAtDeviceXY( X, Y );	{ Set the Globe SelectedObject }
			DisplayObjectData;
		end;
end;

{-------------------------------------------------------------------------}
procedure TForm1.GlobeMouseMove(Sender: TObject; Shift: TShiftState;
	X, Y: Integer);
var
	pt : TPoint;
	sTmp : string;
	MouseObj : TGlobeObject;
begin
	with Globe do
	begin
		DeviceXYToLL( X, Y, pt );

		MouseObj := ObjectAtDeviceXY( X, Y );
		if MouseObj <> nil then
			sTmp := MouseObj.Title
		else
			sTmp := '';

		Caption := Format( '%s %s', [LLPointAsString( pt ), sTmp] );
	end;
end;

{-------------------------------------------------------------------------}
procedure TForm1.cbxLayer0Click(Sender: TObject);
begin
	Globe.Overlays[0].LayerEnabled[TCheckBox( Sender ).Tag] := TCheckBox( Sender ).checked;
end;

{-------------------------------------------------------------------------}
procedure TForm1.btnDeleteClick(Sender: TObject);
begin
	with Globe do
		if SelectedObject <> nil then
		begin
			SelectedObject.Delete;
			Invalidate;		{ re-draw the globe }
		end;
end;

{-------------------------------------------------------------------------}
procedure TForm1.btnUpClick(Sender: TObject);
begin
	Globe.XRotation := Globe.XRotation - 15;
end;

{-------------------------------------------------------------------------}
procedure TForm1.btnDownClick(Sender: TObject);
begin
	Globe.XRotation := Globe.XRotation + 15;
end;

{-------------------------------------------------------------------------}
procedure TForm1.btnRightClick(Sender: TObject);
begin
	Globe.YRotation := Globe.YRotation + 5;
end;

{-------------------------------------------------------------------------}
procedure TForm1.btnLeftClick(Sender: TObject);
begin
	Globe.YRotation := Globe.YRotation - 5;
end;

{-------------------------------------------------------------------------}
procedure TForm1.spinDetailChange(Sender: TObject);
begin
	Globe.DetailLevel := SpinDetail.Value;
end;

{-------------------------------------------------------------------------}
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
begin
	if not ( ssCtrl in Shift )then
		Exit;

	case Key of
	VK_UP :    btnUpClick( Sender );
	VK_RIGHT : btnRightClick( Sender );
	VK_DOWN :  btnDownClick( Sender );
	VK_LEFT :  btnLeftClick( Sender );
	else
		Exit;
	end;
	Key := 0;
end;

{-------------------------------------------------------------------------}
procedure TForm1.SpinLatLongChange(Sender: TObject);
begin
	Globe.LatitudeStep := SpinLatitude.Value;
	Globe.LongitudeStep := SpinLongitude.Value;
end;

{-------------------------------------------------------------------------}
procedure TForm1.btnFillClick(Sender: TObject);
begin
	with Globe do
		if ColorDialog1.Execute then
		begin
			with SelectedObject.Attributes do
				SelectedObject.Attributes := TGlobeAttribute.CreateAttribute(
					ColorDialog1.Color, BrushStyle, PenColour, PenStyle );

			Invalidate;
		end;
end;

{-------------------------------------------------------------------------}
procedure TForm1.btnPenClick(Sender: TObject);
begin
	with Globe do
		if ColorDialog1.Execute then
		begin
			with SelectedObject.Attributes do
				SelectedObject.Attributes := TGlobeAttribute.CreateAttribute(
					BrushColour, BrushStyle, ColorDialog1.Color, PenStyle );

			Invalidate;
		end;
end;

{-------------------------------------------------------------------------}
procedure TForm1.btnExtentsClick(Sender: TObject);
begin
	Globe.ViewRect := Rect( 0,0,0,0 );
end;

{-------------------------------------------------------------------------}
procedure TForm1.DisplayHint(Sender: TObject);
begin
	Panel2.Caption := Application.Hint;
end;

{-------------------------------------------------------------------------}
procedure TForm1.EditTitleChange(Sender: TObject);
begin
	if Globe.selectedobject <> nil then
		Globe.selectedobject.Title := editTitle.text;
end;

{-------------------------------------------------------------------------}
function MinsToRad( iMins : integer ) : Extended;
begin
	{ convert minutes to Radians }
	Result := iMins * ( PI / ( 180.0 * 60 ));
end;

{-------------------------------------------------------------------------}
procedure TForm1.GlobePaint(Sender: TObject);
var
	ptA, ptB : Tpoint;
	iRadius, iLatA, iLatB : integer;
begin
	if not cbxEnableUser.Checked then
		Exit;

	{ displays a scaled 100 minute radius moving circle }
	iRadius := Trunc( 50 * Globe.ScaleFactor ) + 1;

	Globe.Canvas.Brush.Color := clYellow;
	iLatA := Trunc( 2700 * Sin( MinsToRad( iLong )));

	if Globe.LLtoDeviceXY( iLong, iLatA, ptA ) then	{ True if point visible }
		with ptA do
			Globe.Canvas.ellipse( X - iRadius, Y - iRadius, X + iRadius, Y + iRadius );

	{ display second point }
	Globe.Canvas.Brush.Color := clRed;
	iLatB := Trunc( 2700 * Cos( MinsToRad( iLong )));	{ convert minutes to Radians }

	if Globe.LLtoDeviceXY( -iLong, iLatB, ptB ) then	{ True if point visible }
		with ptB do
			Globe.Canvas.ellipse( X - iRadius, Y - iRadius, X + iRadius, Y + iRadius );

	{ joins points }
	Globe.LineLLtoLL( Point( iLong, iLatA ), Point( -iLong, iLatB ));
end;

{-------------------------------------------------------------------------}
procedure TForm1.Timer1Timer(Sender: TObject);
begin
	{ move the circles on a path on each timer tick }
	iLong := iLong + 60;
	if iLong > 10800 then
		iLong := -10800;

	Globe.Invalidate;
end;

{-------------------------------------------------------------------------}
procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
	Timer1.Enabled := False;
	try
		Timer1.Interval := SpinEdit1.Value;
	except
	end;
	Timer1.Enabled := true;
end;

{-------------------------------------------------------------------------}
procedure TForm1.GlobeZoomed(Sender: TObject);
begin
	{ enable / disable text layer dependent on zoom factor }
{	Globe.Overlays[0].LayerEnabled[4] := Globe.ScaleFactor > 0.5;}
end;

{-------------------------------------------------------------------------}
procedure TForm1.GlobeDblClick(Sender: TObject);
begin
	Image1.Picture.Bitmap.Assign( Globe.Bitmap );
	NoteBook1.ActivePage := 'Image';
end;

{-------------------------------------------------------------------------}
procedure TForm1.Image1Click(Sender: TObject);
begin
	NoteBook1.ActivePage := 'Globe';
end;

{-------------------------------------------------------------------------}
procedure TForm1.MercatorProjection1Click(Sender: TObject);
begin
	MercatorProjection1.Checked := not MercatorProjection1.Checked;
	UpdateGlobe;
end;

{-------------------------------------------------------------------------}
procedure TForm1.ShowGrid1Click(Sender: TObject);
begin
	ShowGrid1.Checked := not ShowGrid1.Checked;
	UpdateGlobe;
end;

{-------------------------------------------------------------------------}
procedure TForm1.Gridinfront1Click(Sender: TObject);
begin
	Gridinfront1.Checked := not Gridinfront1.Checked;
	UpdateGlobe;
end;

{-------------------------------------------------------------------------}
procedure TForm1.Exit1Click(Sender: TObject);
begin
	Close;
end;

{-------------------------------------------------------------------------}
procedure TForm1.BaseGlobeFile1Click(Sender: TObject);
begin
	LoadOverlay( Sender, 0 );
end;

{-------------------------------------------------------------------------}
procedure TForm1.Overlay11Click(Sender: TObject);
begin
	LoadOverlay( Sender, 1 );
end;

{-------------------------------------------------------------------------}
procedure TForm1.Overlay21Click(Sender: TObject);
begin
	LoadOverlay( Sender, 2 );
end;

{-------------------------------------------------------------------------}
procedure TForm1.Overlay31Click(Sender: TObject);
begin
	LoadOverlay( Sender, 3 );
end;

{-------------------------------------------------------------------------}
procedure TForm1.Save1Click(Sender: TObject);
begin
	SaveDialog1.FileName := Globe.Overlays[0].Filename;
	if SaveDialog1.Execute then
		Globe.Overlays[0].SaveToFile( SaveDialog1.FileName );
end;


{-------------------------------------------------------------------------}
procedure TForm1.SpinLayerChange(Sender: TObject);
begin
	with SpinLayer do
		if ( Value >= 0 ) and ( Value < 255 ) then
			Globe.SelectedObject.Layer := Value;
end;

end.
